﻿;{ ==Code Header Comment==============================
;        Name/title: frmMain.pb
;   Executable name: NA Paet development of Report Designer Module
;           Version: 1.0
;            Author: Collectordave
;     Collaborators: Amílcar Matos Pérez
;    Translation by: 
;       Create date: 24\01\2016
; Previous releases: 
; This Release Date: 
;  Operating system: Windows  [X]GUI
;  Compiler version: PureBasic 5.41 (x64),PureBasic 5.4LTS(X86)
;         Copyright: (C)2016
;           License: 
;         Libraries: 
;     English Forum: 
;      French Forum: 
;      German Forum: 
;  Tested platforms: Windows
;       Description: Allows configuration of header images
; ====================================================
;.......10........20........30........40........50........60........70........80
;}

DeclareModule ImageProperties
  
  Global Window_ID.i
  Global ActiveGadget.i
  Global OkPressed.i = #False
  
   ;Object Details
   Global RText.s,Rx.i,Ry.i,RMaxWidth.i,RMaxHeight.i
  
  Declare Open()
  
EndDeclareModule

Module ImageProperties
  
Global Window_0

Global btnCancel, btnOk, strFileName, btnSelectImage, strTop, strLeft, strWidth, strHeight, chkAspect

Procedure Open()
  
  Define Quit.i = #False
  Define SelectedImage.s
  
  OkPressed = #False

  Window_ID = OpenWindow(#PB_Any, 0, 0, 600, 110, "", #PB_Window_Tool | #PB_Window_WindowCentered)
  btnCancel = ButtonGadget(#PB_Any, 520, 70, 60, 30, "Cancel")
  btnOk = ButtonGadget(#PB_Any, 450, 70, 60, 30, "Ok")
  strFileName = StringGadget(#PB_Any, 130, 10, 440, 20, RText)
  btnSelectImage = ButtonGadget(#PB_Any, 570, 10, 20, 20, "...")
  TextGadget(#PB_Any, 10, 10, 110, 20, "Image Filename", #PB_Text_Right)
  strTop = StringGadget(#PB_Any, 130, 40, 30, 20, Str(Ry ))
  strLeft = StringGadget(#PB_Any, 210, 40, 30, 20, Str(Rx))
  strWidth = StringGadget(#PB_Any, 300, 40, 30, 20, Str(RMaxWidth))
  strHeight = StringGadget(#PB_Any, 400, 40, 30, 20, Str(RMaxHeight))
  chkAspect = CheckBoxGadget(#PB_Any, 450, 40, 160, 20, "Maintain Aspect Ratio")
  TextGadget(#PB_Any, 70, 40, 40, 20, "Top", #PB_Text_Right)
  TextGadget(#PB_Any, 170, 40, 30, 20, "Left", #PB_Text_Right)
  TextGadget(#PB_Any, 250, 40, 40, 20, "Width", #PB_Text_Right)
  TextGadget(#PB_Any, 340, 40, 50, 20, "Height", #PB_Text_Right)
  
  StickyWindow(Window_ID,#True)
  
  Repeat
    
    Event = WaitWindowEvent()

    Select Event

      Case #PB_Event_Gadget
        Select EventGadget()
            
          Case strTop
            
            Ry = Val(GetGadgetText(strTop))
            
          Case strLeft
            
            Rx = Val(GetGadgetText(strLeft))
            
          Case strHeight
            
            RMaxHeight = Val(GetGadgetText(strHeight))
            
          Case strWidth
            
            RMaxWidth = Val(GetGadgetText(strWidth))
            
          Case btnCancel
          
            OkPressed = #False
            Quit = #True
            CloseWindow(Window_ID)
          
          Case btnOk

            OkPressed = #True
            Quit = #True
            CloseWindow(Window_ID)
          
          Case btnSelectImage
            
            SelectedImage = OpenFileRequester("SELECT IMAGE","","JPEG image (*.jpg;*.jpeg)|*.jpg;*.jpeg",0)
            If SelectedImage > ""
              SetGadgetText(strFileName,SelectedImage)
              RText = SelectedImage
            EndIf
            
        EndSelect
        
    EndSelect
  
Until Quit = #True

EndProcedure

EndModule

; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 107
; FirstLine = 98
; Folding = -
; EnableUnicode
; EnableXP