﻿;{ ==Code Header Comment==============================
;        Name/title: frmMain.pb
;   Executable name: NA Paet development of Report Designer Module
;           Version: 1.0
;            Author: Collectordave
;     Collaborators: Amílcar Matos Pérez
;    Translation by: 
;       Create date: 24\01\2016
; Previous releases: 
; This Release Date: 
;  Operating system: Windows  [X]GUI
;  Compiler version: PureBasic 5.41 (x64),PureBasic 5.4LTS(X86)
;         Copyright: (C)2016
;           License: 
;         Libraries: 
;     English Forum: 
;      French Forum: 
;      German Forum: 
;  Tested platforms: Windows
;       Description: Allows configuratiob of header text
; ====================================================
;.......10........20........30........40........50........60........70........80
;}

DeclareModule TextProperties
  
   Global Window_ID.i
   Global OkPressed.i = #False
   ;Object Details
   Global RText.s,Rx.i,Ry.i,RFontName.s,RFontSize.i,RFontColour.i,RFontStyle.i,RFontID.i
   
   Declare Open()
   
 EndDeclareModule
 
 Module TextProperties

Global Canvas_0, txtFont, strFont, btnSetFont, Text_2, txtTop, strTop, txtLeft, strLeft, btnCentre, btnOk, btnCancel

Global StrTitle.i

Procedure Open()
  
  Define Quit.i = #False
  OkPressed = #False

  Window_ID = OpenWindow(#PB_Any, 0, 0, 420, 220, "", #PB_Window_Tool | #PB_Window_WindowCentered)
  Canvas_0 = CanvasGadget(#PB_Any, 10, 110, 400, 60)
  txtFont = TextGadget(#PB_Any, 20, 40, 50, 20,"Font" , #PB_Text_Right)
  strFont = StringGadget(#PB_Any, 80, 40, 300, 20, RFontName + " " + RFontSize)
  btnSetFont = ButtonGadget(#PB_Any, 380, 40, 20, 20, "...")
  Text_2 = TextGadget(#PB_Any, 10, 110, 190, 20, RText)
  SetGadgetColor(Text_2, #PB_Gadget_BackColor,App::#ColWhite )
  txtTop = TextGadget(#PB_Any, 20, 70, 50, 20, "Top", #PB_Text_Right)
  strTop = StringGadget(#PB_Any, 80, 70, 50, 20, Str(Ry) + "mm")
  txtLeft = TextGadget(#PB_Any, 190, 70, 50, 20, "Left", #PB_Text_Right)
  strLeft = StringGadget(#PB_Any, 250, 70, 50, 20, Str(Rx) + "mm")
  btnCentre = ButtonGadget(#PB_Any, 310, 70, 90, 20, "Centre Area")
  btnOk = ButtonGadget(#PB_Any, 270, 180, 60, 30, "Ok")
  btnCancel = ButtonGadget(#PB_Any, 340, 180, 60, 30, "Cancel")
  StrTitle = StringGadget(#PB_Any, 80, 10, 320, 20, RText)
  txtTitle = TextGadget(#PB_Any, 10, 10, 60, 20, "Title", #PB_Text_Right)

  StartDrawing(WindowOutput(Window_ID))
  DrawingFont(FontID(RFontID)) 
  Height = TextHeight(RText) 
  Width = TextWidth(RText) 
  StopDrawing()
  ResizeGadget(Text_2, #PB_Ignore, #PB_Ignore, Width, Height)
  SetGadgetFont(Text_2, FontID(RFontID))
  SetGadgetColor(Text_2,#PB_Gadget_FrontColor,RFontColour)
  
  StickyWindow(Window_ID,#True)
  
  Repeat
    
    Event = WaitWindowEvent()
       
    Select Event

      Case #PB_Event_Gadget
        
        Select EventGadget()
          
          Case btnSetFont
          
            If FontRequester(RFontName, RFontSize, #PB_FontRequester_Effects,RFontColour,RFontStyle) > 0
              RFontID = LoadFont(#PB_Any, SelectedFontName(), SelectedFontSize(),SelectedFontStyle())
              If RFontID > 0
                RFontName = SelectedFontName()
                RFontSize = SelectedFontSize()
                RFontColour = SelectedFontColor()
                RFontStyle = SelectedFontStyle()
                StartDrawing(WindowOutput(Window_ID))
                DrawingFont(FontID(RFontID)) 
                Height = TextHeight(RText) 
                Width = TextWidth(RText) 
                StopDrawing()
                ResizeGadget(Text_2, #PB_Ignore, #PB_Ignore, Width, Height)
                SetGadgetFont(Text_2, FontID(RFontID))
                SetGadgetColor(Text_2,#PB_Gadget_FrontColor,RFontColour)
              EndIf
              
            Else
              
              App::Message("Report Header Font", "Problem Loading Font Please Reselect!",App::#OkOnly|App::#InformationIcon)     

            EndIf
            
          Case StrTitle 
            
            RText = GetGadgetText(StrTitle)
            
          Case   strLeft
            
            Rx = Val(GetGadgetText(strLeft))
            
          Case strTop
            
            Ry = Val(GetGadgetText(strTop))
            
          Case btnOk

            Quit = #True  
            OkPressed = #True
            CloseWindow(Window_ID)
          
          Case btnCancel
            
            Quit = #True
            OkPressed = #False
            CloseWindow(Window_ID)
          
      EndSelect ;EventGadget()

  EndSelect ;Event
  
Until Quit = #True

EndProcedure

EndModule
; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 99
; FirstLine = 56
; Folding = +
; EnableUnicode
; EnableXP